/**
 * Ported from the Java example program in
 * Head First Design Patterns, 1st edition
 * by Eric Freeman, Bert Bates, and Elizabeth Robson
 * O'Reilly, 2004
 * ISBN 978-0596007126
 *
 * Ported to C++ by:
 * Ronald Mak, Nov. 2019
 * Department of Computer Engineering
 * San Jose State University
 */
#ifndef HASQUARTERSTATE_H_
#define HASQUARTERSTATE_H_

#include <stdlib.h>
#include <time.h>
#include <string>

#include "State.h"

class GumballMachine;

class HasQuarterState: public State
{
private:
    GumballMachine *gumball_machine;

public:
    HasQuarterState(GumballMachine *gm) : gumball_machine(gm)
    {
        srand(time(0));
    }

    virtual ~HasQuarterState() {}

    void insert_quarter();
    void eject_quarter();
    void turn_crank();
    void dispense();

    string message() const { return "waiting for turn of crank"; }
};

#endif /* HASQUARTERSTATE_H_ */
