/**
 * Ported from the Java example program in
 * Head First Design Patterns, 1st edition
 * by Eric Freeman, Bert Bates, and Elizabeth Robson
 * O'Reilly, 2004
 * ISBN 978-0596007126
 *
 * Ported to C++ by:
 * Ronald Mak, Nov. 2019
 * Department of Computer Engineering
 * San Jose State University
 */
#ifndef SOLDOUTSTATE_H_
#define SOLDOUTSTATE_H_

#include "State.h"

class GumballMachine;

class SoldOutState: public State
{
private:
    GumballMachine *gumball_machine;

public:
    SoldOutState(GumballMachine *gm) : gumball_machine(gm) {}
    virtual ~SoldOutState() {}

    void insert_quarter();
    void eject_quarter();
    void turn_crank();
    void dispense();

    void refill();

    string message() const { return "sold out"; }
};

#endif /* SOLDOUTSTATE_H_ */
