/**
 * Ported from the Java example program in
 * Head First Design Patterns, 1st edition
 * by Eric Freeman, Bert Bates, and Elizabeth Robson
 * O'Reilly, 2004
 * ISBN 978-0596007126
 *
 * Ported to C++ by:
 * Ronald Mak, Nov. 2019
 * Department of Computer Engineering
 * San Jose State University
 */
#ifndef STATE_H_
#define STATE_H_

#include <iostream>
#include <string>

using namespace std;

class State
{
public:
    State() {}
    virtual ~State() {}

    virtual void insert_quarter() = 0;
    virtual void eject_quarter() = 0;
    virtual void turn_crank() = 0;
    virtual void dispense() = 0;

    virtual string message() const = 0;

    void refill() {}

    friend ostream& operator <<(ostream& os, const State& state);
};

#endif /* STATE_H_ */
