/**
 * Ported from the Java example program in
 * Head First Design Patterns, 1st edition
 * by Eric Freeman, Bert Bates, and Elizabeth Robson
 * O'Reilly, 2004
 * ISBN 978-0596007126
 *
 * Ported to C++ by:
 * Ronald Mak, Nov. 2019
 * Department of Computer Engineering
 * San Jose State University
 */
#ifndef WINNERSTATE_H_
#define WINNERSTATE_H_

#include "State.h"

class GumballMachine;

class WinnerState: public State
{
private:
    GumballMachine *gumball_machine;

public:
    WinnerState(GumballMachine *gm) : gumball_machine(gm) {}
    virtual ~WinnerState() {}

    void insert_quarter();
    void eject_quarter();
    void turn_crank();
    void dispense();

    string message() const
    {
        return string("dispensing two gumballs for your quarter, ") +
               string("because YOU'RE A WINNER!");
    }
};

#endif /* WINNERSTATE_H_ */
